//Code für Arduino2 im Adventshaus
// SPI interface for the screen must be wired to specific pins (e.g. for Arduino Uno,
// MOSI = pin 11, MISO = 12, SCK = 13). Other pins are configurable.
//#include <SmallSetup.h>
#include <Adafruit_GFX.h>          // Kern library
#include <Adafruit_ST7735.h>       // 1.8" TFT library
#include <SdFat.h>                 // SD card & FAT filesystem library
#include <Adafruit_ImageReader.h>  // bmp Lesefunktionen
#include <Wire.h>                  // Zeit und Datum I2C
String bild = "";                  //leerer String für Bildnummer
int pic; 
int zeige=0; 
int event, event2;     //integer vars für empfang von Ardu1
char *text;
#define NODE_ADDRESS 2
#define PAYLOAD_SIZE 20  // Adjust the size accordingly

// TFT und SD card teilen sich das SPI interface, Auswahl der Geräte über die CS-Pins

#define SD_CS 5   // SD card select pin
#define TFT_CS 2  // TFT select pin
#define TFT_DC 3  // TFT display/command pin
#define TFT_RST -1
const char *filename;

SdFat SD;                         // SD Objekt
Adafruit_ImageReader reader(SD);  // Bildleser Objekt, weitergeleitet zu SD Dateisystem
FatVolume filesys;                // Objekt Dateisystem FAT
Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS, TFT_DC, TFT_RST);
Adafruit_Image img;                 // Bild im RAM
int32_t width = 160, height = 128;  // BMP Bildformat wie TFT Display
ImageReturnCode stat;               // Status des Bildlesers



//°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°
void receiveEvent() {
  String receivedData = "";

  while (Wire.available()) {
    char c = Wire.read();
    receivedData += c;
  }

  // Split the received data into individual values
  int values[4];
  int index = 0;
  String value = "";

  for (char c : receivedData) {
    if (c == ',') {
      values[index++] = value.toInt();
      value = "";
    } else {
      value += c;
    }
  }
  bild = values[0];
  *text = "heute um 20:30 ";
  values[index] = value.toInt();
  pic = values[0];
  zeige = values[1];
  event = values[2];
  event2= values[3];
  while (zeige == 0);
    aus();
  
}
//°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°
//Textausgabe
void drawText (char *text, uint16_t color) {
   tft.setCursor(5, 0);
  tft.setTextColor(color);
  tft.setTextWrap(true);
  tft.print(text);
}
//°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°
//Bildwechsel und Tonausgabe

void aus() {

  if (zeige == 1) {
    Serial.println(F("VoidAusgabe"));
    Serial.println(zeige);
    while (zeige == 0)
      ;  //warten bis zeige auf 1 geht...
    //Dateiname für aktuelles Bild auf SD zusammensetzen:
    String zwei = bild + ".bmp";
    Serial.print("Bild:");
    Serial.println(zwei);

    // Umwandlung String to char* (erforderlich weil Bild sonst nicht angezeigt wird)
    const char *filename = zwei.c_str();
    

    if (event2==2){   //Wartebildanzeigen wenn event2=2
  filename="200.bmp";
}

    // Display bitmap
   
    tft.fillScreen(ST7735_BLUE);
    reader.drawBMP(filename, tft, 0, 0);  // Bild anzeigen auf Display
     stat = reader.drawBMP(filename, tft, 0, 0);
   reader.printStatus(stat);  // Kontrollfunktion..
    zeige = 0;                            //blockiert weitere anzeige bis zum nächsten Datenempfang
  }
}
//°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°

void setup() {
  Serial.begin(115200);
  Serial.println(F("BeginSetup"));


  ImageReturnCode stat;  // Status Bildleser


pinMode(6,INPUT_PULLUP);
  //Display
  Serial.println(F("DisplayInit"));
  tft.initR(INITR_BLACKTAB);  // Bildschirm initialisieren
  // Der Adafruit_ImageReader constructor call (Zeile 35, vor setup())
  // empfängt ein  SdFat oder FatVolume Objekt. Dieses MUSS
  // initialisiert werden bevor irgendeine Bildlesefunktion aufgerufen wird:

  Serial.print(F("Initializing filesystem..."));
  // Der SD Kartenleser wird mit nur einem Aufruf angesprochen......
  if (!SD.begin(SD_CS, SD_SCK_MHZ(8))) {  // Wegen längerer Drähte nur mit geringerer Frequenz!

    Serial.println(F("SD begin() failed"));
    for (;;)
      ;  // Kartenlesefehler --  Programm hält dann hier an...
  }
  Serial.println(F("SD OK!"));
  // Die Bildschirmfüllung ist nicht notwendig, aber zeigt an, dass das Display richtig arbeitet.
  tft.fillScreen(ST7735_RED);
  tft.setRotation(3);  // Drehung des Bildes um 270° wegen Einbaulage des Displays im Modell
  delay(3000);

  Wire.begin(NODE_ADDRESS);
  Wire.onReceive(receiveEvent);

}  //ende Setup
//°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°



void loop() {

 
  //Daten holen von Ardu1 und warten auf nächste Ausgabe...
}
